/*
 * @(#)ServiceContextListener.java	1.11 00/08/06
 *
 * Copyright 1998-2000 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package javax.tv.service.selection;

import java.util.EventListener;


/**
 * The <code>ServiceContextListener</code> interface is implemented by
 * applications wishing to receive events related to service contexts.
 *
 * @see ServiceContext */
public interface ServiceContextListener extends EventListener {

  /**
   * Notifies the <code>ServiceContextListener</code> of an event
   * generated by a <code>ServiceContext</code>.
   *
   * @param e The generated event.
   */
  public abstract void receiveServiceContextEvent(ServiceContextEvent e);
}

